/*
* Copyright (C) 2020, Tianjin KYLIN Information Technology Co., Ltd.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 3, or (at your option)
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, see <http://www.gnu.org/licenses/&gt;.
*
*/
#ifndef MEDIAPLAYERPOOL_H
#define MEDIAPLAYERPOOL_H

#include <QObject>
#include "object_pool.h"
#include <QMediaPlayer>
#include "mediaplayerthread.h"
class MediaPlayerPool : public QObject
{
    Q_OBJECT
public:
    QMediaPlayer * getQMediaPlayer();
    void pushBackQMediaPlayer(QMediaPlayer * player);
    ~MediaPlayerPool();
    MediaPlayerPool(const MediaPlayerPool&)=delete;
    MediaPlayerPool& operator=(const MediaPlayerPool&)=delete;
    static MediaPlayerPool* getInstance(){
        static MediaPlayerPool instance;
        return &instance;
    }

    MediaPlayerThread *getWorkerThread() const;

signals:



private:
    void createQMediaPlayerPool(int size);
    explicit MediaPlayerPool(int size=3,QObject *parent = nullptr);
    ObjectPool<QMediaPlayer> * m_qMediaPlayerPool = nullptr;
    int m_size=0;
    MediaPlayerThread *workerThread = nullptr;

};

#endif // MEDIAPLAYERPOOL_H
